本篇文章中的题解是我在比赛中的思路或者所写的代码, 总结出的一篇相对来说比较清晰的个人题解, 希望要备战蓝桥杯的小伙伴能够看到最后(注意:本次Java组和C++组的题目不一样,本文所写的题目均为Java组的)~
填空题
最小数
问题描述:请找到一个大于 2022 的最小数,这个数转换成十六进制之后,所有的数位(不含前导 0)都为字母(A 到 F)。
请将这个数的十进制形式作为答案提交。
思路:从2022开始,每次往后遍历一个数,并将这个数转化成十六进制的形式,并判断是否全部都在A到F之间即可。
Java代码:
import java.util.*;
public class Main{
public static boolean getNum(int x){
List<Integer> list = new ArrayList<>();
while(x > 0){
int tmp = x % 16;
list.add(tmp);
x /= 16;
}
for(int t : list){
if(t < 10) return false;
}
return true;
}
public static void main(String[] args){
int x = 2023;
while(true){
if(getNum(x)){
System.out.println(x);
return;
}
x++;
}
}
}
答案:2730
Excel的列
问题描述:在 Excel 中,列的名称使用英文字母的组合。前 26 列用一个字母,依次为 A 到 Z,接下来 26*26 列使用两个字母的组合,依次为 AA 到 ZZ。
请问第 2022 列的名称是什么?
思路:我们可以使用计算器简单地算一下:发现一个字母的情况和两个字母的情况加起来不会超过2022,而在有三个字母的情况下则会超出,因此我们可以确定2022列一定是三个字母的,所以直接暴力三重循环进行求解即可。
Java代码:
import java.util.*;
public class Main{
public static void main(String[] args){
int x = 2022 - 26 - 676;
for(int i = 0; i < 26; i++){
for(int j = 0; j < 26; j++){
for(int k = 0; k < 26; k++){
x--;
if(x == 0){
System.out.println((char)('A' + i) + " " + (char)('A' + j) + " " + (char)('A' + k));
return;
}
}
}
}
}
}
答案:BYT
日期数
问题描述:对于一个日期,我们可以计算出年份的各个数位上的数字之和,也可以分别计算月和日的各位数字之和。请问从 1900 年 1 月 1 日至 9999 年 12 月 31 日,总共有多少天,年份的数位数字之和等于月的数位数字之和加日的数位数字之和。
例如,2022年11月13日满足要求,因为 2+0+2+2=(1+1)+(1+3) 。
请提交满足条件的日期的总数量。
思路:遍历从1990年到9999年中的所有年份,取出满足年份的各个数位上的数字之和等于月和日的各位数字之和的日期,最后判断这个日期是否是合法的即可。
Java代码:
import java.util.*;
public class Main{
public static int[] days = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
public static boolean isDate(int y, int m, int d){
if((y % 4 == 0 && y % 100 != 0) || (y % 400 == 0)){
if(m == 2){
if(d > 29) return false;
else return true;
}else{
if(d > days[m]) return false;
else return true;
}
}
if(d > days[m]) return false;
return true;
}
public static void main(String[] args){
int res = 0;
for(int i = 1900; i <= 9999; i++){
int x = i;
int sum = 0;
while(x > 0){
sum += x % 10;
x /= 10;
}
for(int j = 1; j <= 12; j++){
int t1 = j;
if(t1 >= 10) t1 -= 9;
for(int k = 1; k <= 31; k++){
int y = k;
int t2 = 0;
while(y > 0){
t2 += y % 10;
y /= 10;
}
if(t1 + t2 == sum && isDate(i, j, k)) res++;
}
}
}
System.out.println(res);
}
}
答案:70910
取数
问题描述:小蓝有 30 个数,分别为:99, 22, 51, 63, 72, 61, 20, 88, 40, 21, 63, 30, 11, 18, 99, 12, 93, 16, 7, 53, 64, 9, 28, 84, 34, 96, 52, 82, 51, 77 。
小蓝可以在这些数中取出两个序号不同的数,共有 30*29/2=435 种取法。
请问这 435 种取法中,有多少种取法取出的两个数的乘积大于等于 2022 。
思路:直接暴力枚举数组中的两个数,判断它们的乘积即可。
Java代码:
import java.util.*;
public class Main{
public static void main(String[] args){
int res = 0;
int[] a = {99, 22, 51, 63, 72, 61, 20, 88, 40, 21, 63, 30, 11, 18, 99, 12, 93, 16, 7, 53, 64, 9, 28, 84, 34, 96, 52, 82, 51, 77};
for(int i = 0; i < a.length; i++){
for(int j = i + 1; j < a.length; j++){
if(a[i] * a[j] >= 2022) res++;
}
}
System.out.println(res);
}
}
答案:189
最大连通块
问题描述:小蓝有一个 30 行 60 列的数字矩阵,矩阵中的每个数都是 0 或 1 。
110010000011111110101001001001101010111011011011101001111110
010000000001010001101100000010010110001111100010101100011110
001011101000100011111111111010000010010101010111001000010100
101100001101011101101011011001000110111111010000000110110000
010101100100010000111000100111100110001110111101010011001011
010011011010011110111101111001001001010111110001101000100011
101001011000110100001101011000000110110110100100110111101011
101111000000101000111001100010110000100110001001000101011001
001110111010001011110000001111100001010101001110011010101110
001010101000110001011111001010111111100110000011011111101010
011111100011001110100101001011110011000101011000100111001011
011010001101011110011011111010111110010100101000110111010110
001110000111100100101110001011101010001100010111110111011011
111100001000001100010110101100111001001111100100110000001101
001110010000000111011110000011000010101000111000000110101101
100100011101011111001101001010011111110010111101000010000111
110010100110101100001101111101010011000110101100000110001010
110101101100001110000100010001001010100010110100100001000011
100100000100001101010101001101000101101000000101111110001010
101101011010101000111110110000110100000010011111111100110010
101111000100000100011000010001011111001010010001010110001010
001010001110101010000100010011101001010101101101010111100101
001111110000101100010111111100000100101010000001011101100001
101011110010000010010110000100001010011111100011011000110010
011110010100011101100101111101000001011100001011010001110011
000101000101000010010010110111000010101111001101100110011100
100011100110011111000110011001111100001110110111001001000111
111011000110001000110111011001011110010010010110101000011111
011110011110110110011011001011010000100100101010110000010011
010011110011100101010101111010001001001111101111101110011101
如果从一个标为 1 的位置可以通过上下左右走到另一个标为 1 的位置,则称两个位置连通。与某一个标为 1 的位置连通的所有位置(包括自己)组成一个连通分块。
请问矩阵中最大的连通分块有多大?
思路:使用深度优先搜索的思想,首先找到一个还没有被使用过的位置,从这个位置开始对上下左右进行搜索,并在每次dfs后更新一下最大值即可。
Java代码:
import java.util.*;
public class Main{
public static int[] getX = {0, 1, 0, -1};
public static int[] getY = {1, 0, -1, 0};
public static int cnt = 0;
public static void dfs(char[][] a, boolean[][] st, int x, int y){
st[x][y] = true;
for(int i = 0; i < 4; i++){
int newx = x + getX[i];
int newy = y + getY[i];
if(newx >= 0 && newx < 30 && newy >= 0 && newy < 60 && a[newx][newy] == '1' && st[newx][newy] == false){
cnt++;
dfs(a, st, newx, newy);
}
}
}
public static void main(String[] args){
Scanner scanner = new Scanner(System.in);
char[][] a = new char[35][65];
boolean[][] st = new boolean[35][65];
for(int i = 0; i < 30; i++){
String s = scanner.next();
a[i] = s.toCharArray();
}
int res = 0;
for(int i = 0; i < 30; i++){
for(int j = 0; j < 60; j++){
if(a[i][j] == '1' && st[i][j] == false){
cnt = 1;
dfs(a, st, i, j);
res = Math.max(res, cnt);
}
}
}
System.out.println(res);
}
}
答案:148
编程题
一周第几天
问题描述:给定一天是一周中的哪天,请问 n 天后是一周中的哪天?
输入格式
输入第一行包含一个整数 w,表示给定的天是一周中的哪天,w 为 1 到 6 分别表示周一到周六,w 为 7 表示周日。
第二行包含一个整数 n。
输出格式
输出一行包含一个整数,表示 n 天后是一周中的哪天,1 到 6 分别表示周一到周六,7 表示周日。
样例输入
6
10
样例输出
2
评测用例规模与约定
对于所有评测用例,1 <= n <= 1000000。
思路:直接+n天之后模7就可以得到最终是星期几,但是有一个需要注意,如果结果是0,需要将其手动变为7即可。
Java代码:
import java.util.*;
public class Main{
public static void main(String[] args){
Scanner scanner = new Scanner(System.in);
int w = scanner.nextInt();
int n = scanner.nextInt();
int res = (w + n) % 7;
if(res == 0) res = 7;
System.out.println(res);
}
}
被覆盖的点
问题描述:小蓝负责一块区域的信号塔安装,整块区域是一个长方形区域,建立坐标轴后,西南角坐标为 (0, 0), 东南角坐标为 (W, 0), 西北角坐标为 (0, H), 东北角坐标为 (W, H)。其中 W, H 都是整数。
他在 n 个位置设置了信号塔,每个信号塔可以覆盖以自己为圆心,半径为 R 的圆形(包括边缘)。
为了对信号覆盖的情况进行检查,小蓝打算在区域内的所有横纵坐标为整数的点进行测试,检查信号状态。其中横坐标范围为 0 到 W,纵坐标范围为 0 到 H,总共测试 (W+1) * (H+1) 个点。
给定信号塔的位置,请问这 (W+1)*(H+1) 个点中有多少个点被信号覆盖。
输入格式
输入第一行包含四个整数 W, H, n, R,相邻整数之间使用一个空格分隔。
接下来 n 行,每行包含两个整数 x, y,表示一个信号塔的坐标。信号塔可能重合,表示两个信号发射器装在了同一个位置。
输出格式
输出一行包含一个整数,表示答案。
样例输入
10 10 2 5
0 0
7 0
样例输出
57
评测用例规模与约定
对于所有评测用例,1 <= W, H <= 100,1 <= n <= 100, 1 <= R <= 100, 0 <= x <= W, 0 <= y <= H。
思路:由于这道题的数据量比较小,我们可以先把所有信号塔的坐标都存起来,之后暴力地遍历整块区域中的所有点,判断该点到所有信号塔的距离是否有在半径的范围之内,如果存在其中,则结果++。值得注意的是,如果只是单纯执行上述的步骤,答案是错的,因为有可能会有一个点计算两次的情况,因此我们需要额外的一个数组来存当前点是否已经存在过了,如果之前就已经加过了,那么久不需要再执行此操作。
Java代码:
import java.util.*;
class Pair{
public int x;
public int y;
public Pair(int x, int y){
this.x = x;
this.y = y;
}
}
public class Main{
public static boolean[][] st = new boolean[110][110];
public static boolean check(int i, int j, Pair pair, int r){
int x = pair.x;
int y = pair.y;
if((x - i) * (x - i) + (y - j) * (y - j) <= r * r){
st[i][j] = true;
return true;
}
return false;
}
public static void main(String[] args){
Scanner scanner = new Scanner(System.in);
int w = scanner.nextInt();
int h = scanner.nextInt();
int n = scanner.nextInt();
int r = scanner.nextInt();
List<Pair> list = new ArrayList<>();
while(n-- > 0){
int x = scanner.nextInt();
int y = scanner.nextInt();
list.add(new Pair(x, y));
}
int res = 0;
for(int i = 0; i <= w; i++){
for(int j = 0; j <= h; j++){
for(int k = 0; k < list.size(); k++){
if(st[i][j] == false && check(i, j, list.get(k), r)) res++;
}
}
}
System.out.println(res);
}
}
未被清理的区域
问题描述:小蓝有一个 n * m 大小的矩形水域,小蓝将这个水域划分为 n 行 m 列,行数从 1 到 n 标号,列数从 1 到 m 标号。每行和每列的宽度都是单位 1 。
现在,这个水域长满了水草,小蓝要清理水草。
每次,小蓝可以清理一块矩形的区域,从第 r1 行(含)到第 r2 行(含)的第 c1 列(含)到 c2 列(含)。
经过一段时间清理后,请问还有多少地方没有被清理过。
输入格式
输入第一行包含两个整数 n, m,用一个空格分隔。
第二行包含一个整数 t ,表示清理的次数。
接下来 t 行,每行四个整数 r1, c1, r2, c2,相邻整数之间用一个空格分隔,表示一次清理。请注意输入的顺序。
输出格式
输出一行包含一个整数,表示没有被清理过的面积。
样例输入
2 3
2
1 1 1 3
1 2 2 2
样例输出
2
样例输入
30 20
2
5 5 10 15
6 7 15 9
样例输出
519
评测用例规模与约定
对于所有评测用例,1 <= r1 <= r2 <= n <= 100, 1 <= c1 <= c2 <= m <= 100, 0 <= t <= 100。
思路:如果你做过差分类型的题目,这道题其实一眼就可以看出来是差分思想,虽然说这道题数据量不大,但是是一个二维矩阵,直接使用暴力的做法可能会超时,因此我们存的是一个差分矩阵,最后再使用一遍前缀和就可以会快解出这道题了。
Java代码:
import java.util.*;
public class Main{
public static void main(String[] args){
Scanner scanner = new Scanner(System.in);
int n = scanner.nextInt();
int m = scanner.nextInt();
int t = scanner.nextInt();
int[][] a = new int[n + 10][m + 10];
while(t-- > 0){
int r1 = scanner.nextInt();
int c1 = scanner.nextInt();
int r2 = scanner.nextInt();
int c2 = scanner.nextInt();
a[r1][c1]++;
a[r2 + 1][c1]--;
a[r1][c2 + 1]--;
a[r2 + 1][c2 + 1]++;
}
int res = 0;
for(int i = 1; i <= n; i++){
for(int j = 1; j <= m; j++){
a[i][j] += a[i - 1][j] + a[i][j - 1] - a[i - 1][j - 1];
if(a[i][j] == 0) res++;
}
}
System.out.println(res);
}
}
滑行距离
问题描述:小蓝准备在一个空旷的场地里面滑行,这个场地的高度不一,小蓝用一个 n 行 m 列的矩阵来表示场地,矩阵中的数值表示场地的高度。
如果小蓝在某个位置,而他上、下、左、右中有一个位置的高度(严格)低于当前的高度,小蓝就可以滑过去,滑动距离为 1 。
如果小蓝在某个位置,而他上、下、左、右中所有位置的高度都大于等于当前的高度,小蓝的滑行就结束了。
小蓝不能滑出矩阵所表示的场地。
小蓝可以任意选择一个位置开始滑行,请问小蓝最多能滑行多远距离。
输入格式
输入第一行包含两个整数 n, m,用一个空格分隔。
接下来 n 行,每行包含 m 个整数,相邻整数之间用一个空格分隔,依次表示每个位置的高度。
输出格式
输出一行包含一个整数,表示答案。
样例输入
4 5
1 4 6 3 1
11 8 7 3 1
9 4 5 2 1
1 3 2 2 1
样例输出
7
样例说明
滑行的位置一次为 (2, 1), (2, 2), (2, 3), (3, 3), (3, 2), (4, 2), (4, 3)。
评测用例规模与约定
对于 30% 评测用例,1 <= n <= 20,1 <= m <= 20,0 <= 高度 <= 100。
对于所有评测用例,1 <= n <= 100,1 <= m <= 100,0 <= 高度 <= 10000。
思路:这道题其实跟前面填空题最后一道题是很像的,数据量都比较小,使用dfs思想解决即可。值得注意的是,这道题我们不再需要有额外的一个数组来存储当前点是否被使用过,原因是题目中要求了下一个位置要严格低于当前位置才能进行滑行(也就是说,只能从高往低滑,不能反过来),由于每条路上都可能会有分支,所以在dfs之后还需要进行一下回溯即可。
Java代码:
import java.util.*;
public class Main{
public static int[] getX = {0, 1, 0, -1};
public static int[] getY = {1, 0, -1, 0};
public static int cnt = 0;
public static void dfs(int[][] h, int x, int y, int n, int m, int l){
for(int i = 0; i < 4; i++){
int newx = x + getX[i];
int newy = y + getY[i];
if(newx >= 0 && newx < n && newy >= 0 && newy < m && h[newx][newy] < h[x][y]){
l++;
cnt = Math.max(cnt, l);
dfs(h, newx, newy, n, m, l);
l--;
}
}
}
public static void main(String[] args){
Scanner scanner = new Scanner(System.in);
int n = scanner.nextInt();
int m = scanner.nextInt();
int[][] h = new int[n][m];
for(int i = 0; i < n; i++){
for(int j = 0; j < m; j++){
h[i][j] = scanner.nextInt();
}
}
int res = 0;
for(int i = 0; i < n; i++){
for(int j = 0; j < m; j++){
cnt = 0;
dfs(h, i, j, n, m, 1);
res = Math.max(res, cnt);
}
}
System.out.println(res);
}
}
区间最小值
问题描述:小蓝有一个序列 a[1], a[2], …, a[n]。
给定一个正整数 k,请问对于每一个 1 到 n 之间的序号 i,a[i-k], a[i-k+1], …, a[i+k] 这 2k+1 个数中的最小值是多少?当某个下标超过 1 到 n 的范围时,数不存在,求最小值时只取存在的那些值。
输入格式
输入的第一行包含一整数 n。
第二行包含 n 个整数,分别表示 a[1], a[2], …, a[n]。
第三行包含一个整数 k 。
输出格式
输出一行,包含 n 个整数,分别表示对于每个序号求得的最小值。
样例输入
5
5 2 7 4 3
1
样例输出
2 2 2 3 3
评测用例规模与约定
对于 30% 的评测用例,1 <= n <= 1000,1 <= a[i] <= 1000。
对于 50% 的评测用例,1 <= n <= 10000,1 <= a[i] <= 10000。
对于所有评测用例,1 <= n <= 1000000,1 <= a[i] <= 1000000。
思路:这道题使用到的是单调队列的算法,如果不会这个算法的小伙伴可以直接使用暴力(混部分分~),原因是这道题数据范围是比较大的,我们需要将时间复杂度控制在O(n)或一下,O(nlogn)可能还是有点悬。单调队列其实就是一个滑动窗口,详细一点来说就是一个知道当前窗口中最大或者最小值的一个可以滑动等长子序列。
而这道题要求的是一个元素从左边k个位置开始到右边k个位置这段区间的最小值,所以我们可以使用两个滑动窗口,一个从前往后遍历(求出当前位置之前的k个元素的最小值),另外一个从后往前遍历(求出当前位置之后的k个元素的最小值),最后每个元素上的最小值就是两个单调队列在该位置上的较小值,即为该元素从左边k个位置开始到右边k个位置这段区间的最小值。
Java代码:
import java.util.*;
public class Main{
public static void main(String[] args){
Scanner scanner = new Scanner(System.in);
int n = scanner.nextInt();
int[] a = new int[n];
for(int i = 0; i < n; i++) a[i] = scanner.nextInt();
int k = scanner.nextInt();
int[] q1 = new int[n];
int[] q2 = new int[n];
int[] res = new int[n];
int hh = 0, tt = -1;
for(int i = 0; i < n; i++){
if(hh <= tt && q1[hh] < i - k) hh++;
while(hh <= tt && a[q1[tt]] >= a[i]) tt--;
q1[++tt] = i;
res[i] = a[q1[hh]];
}
hh = 0;
tt = -1;
for(int i = n - 1; i >= 0; i--){
if(hh <= tt && q2[hh] > i + k) hh++;
while(hh <= tt && a[q2[tt]] >= a[i]) tt--;
q2[++tt] = i;
res[i] = Math.min(res[i], a[q2[hh]]);
}
for(int i = 0; i < n; i++){
System.out.print(res[i] + " ");
}
}
}
最后,文本只是我个人的思路及代码,可能存在错误,大家如果有发现错误的,可以在下面评论区中指出,感谢观看~